package com.dyonovan.neotech.network;

import com.dyonovan.neotech.lib.Reference;
import net.minecraftforge.fml.common.network.NetworkRegistry;
import net.minecraftforge.fml.common.network.simpleimpl.SimpleNetworkWrapper;
import net.minecraftforge.fml.relauncher.Side;

/**
 * This file was created for NeoTech
 *
 * NeoTech is licensed under the Creative Commons Attribution-NonCommercial-ShareAlike 4.0 International License:
 * http://creativecommons.org/licenses/by-nc-sa/4.0/
 *
 * @author Paul Davis pauljoda
 * @since August 15, 2015
 */
public class PacketDispatcher {
    public static SimpleNetworkWrapper net;
    private static int nextPacketId = 0;

    public static void initPackets() {
        net = NetworkRegistry.INSTANCE.newSimpleChannel(Reference.MOD_ID().toUpperCase());

        registerMessage(OpenContainerGui.class, OpenContainerGui.class);
        registerMessage(DrainEnergyPacketArmor.class, DrainEnergyPacketArmor.class);
        registerMessage(UpdateToolTag.class, UpdateToolTag.class);
        registerMessage(ResetFallDistance.class, ResetFallDistance.class);
        registerMessage(SpawnJetpackParticles.class, SpawnJetpackParticles.class);
        registerMessage(RemoveFallDamage.class, RemoveFallDamage.class);
    }

    @SuppressWarnings("unchecked")
    private static void registerMessage(Class packet, Class message) {
        net.registerMessage(packet, message, nextPacketId, Side.CLIENT);
        net.registerMessage(packet, message, nextPacketId, Side.SERVER);
        nextPacketId++;
    }
}
